'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _LookUp = require('../LookUp');

var _LookUp2 = _interopRequireDefault(_LookUp);

var _Fieldset = require('../Fieldset');

var _Fieldset2 = _interopRequireDefault(_Fieldset);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Address = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Address, _Component);

  function Address(props) {
    (0, _classCallCheck3.default)(this, Address);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Address.__proto__ || (0, _getPrototypeOf2.default)(Address)).call(this, props));

    _this.lookUpFields = {
      street: {
        formKey: 'address_street' + props.formKeySuffix,
        apiValue: function apiValue(address) {
          return address.street;
        },
        hideField: true
      },
      postcode: {
        formKey: 'address_postcode' + props.formKeySuffix,
        apiValue: function apiValue() {
          return false;
        },
        triggerLookup: true
      },
      number: {
        formKey: 'address_number' + props.formKeySuffix,
        apiValue: function apiValue() {
          return false;
        },
        triggerLookup: true
      },
      addition: {
        formKey: 'address_number_add' + props.formKeySuffix,
        apiValue: function apiValue() {
          return false;
        },
        triggerLookup: true
      },
      city: {
        formKey: 'address_city' + props.formKeySuffix,
        apiValue: function apiValue(address) {
          return address.city.label;
        },
        hideField: true
      },
      locationLat: {
        formKey: 'address_location_lat' + props.formKeySuffix,
        apiValue: function apiValue(address) {
          return address.geo.center.wgs84.coordinates[1];
        }
      },
      locationLng: {
        formKey: 'address_location_lng' + props.formKeySuffix,
        apiValue: function apiValue(address) {
          return address.geo.center.wgs84.coordinates[0];
        }
      },
      manualOverride: {
        formKey: 'address_manual_override' + props.formKeySuffix,
        apiValue: function apiValue() {
          return false;
        }
      }
    };

    _this.lookUpBase = props.webformSettings.cmsBaseUrl + '/postcode-api/address?_format=json';
    return _this;
  }

  (0, _createClass3.default)(Address, [{
    key: 'prepareLookUp',
    value: function prepareLookUp(fields) {
      var postCodeField = this.props.getField('postcode').field;

      if (!fields.postcode || !postCodeField || !postCodeField.valid) {
        return false;
      }

      var query = '&postcode=' + fields.postcode + (fields.number ? '&number=' + fields.number + (fields.addition || '') : '');

      return {
        query: query,
        // eslint-disable-next-line no-underscore-dangle
        checkResponse: function checkResponse(json) {
          return json;
        },
        isSuccessful: function isSuccessful(json) {
          return !!json.id;
        }
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_Fieldset2.default, (0, _extends3.default)({}, this.props, {
        onBlur: this.props.onBlur,
        onChange: this.props.onChange
      }));
    }
  }]);
  return Address;
}(_react.Component), _class2.meta = {
  wrapper: _react2.default.createElement('fieldset', null),
  label: _react2.default.createElement('legend', null),
  labelVisibility: _Fieldset2.default.meta.labelVisibility,
  hasValue: false
}, _class2.propTypes = {
  getField: _propTypes2.default.func.isRequired,
  webformSettings: _propTypes2.default.shape({
    cmsBaseUrl: _propTypes2.default.string.isRequired
  }).isRequired,
  onBlur: _propTypes2.default.func.isRequired,
  onChange: _propTypes2.default.func.isRequired,
  formKeySuffix: _propTypes2.default.string.isRequired
}, _temp)) || _class;

exports.default = (0, _LookUp2.default)(Address);