'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactCssModules = require('react-css-modules');

var _reactCssModules2 = _interopRequireDefault(_reactCssModules);

var _styles = require('./styles.pcss');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BaseButton = function BaseButton(_ref) {
  var disabled = _ref.disabled,
      label = _ref.label,
      formSubmitAttributes = _ref.formSubmitAttributes,
      onClick = _ref.onClick,
      isPrimary = _ref.isPrimary,
      type = _ref.type;
  return _react2.default.createElement(
    'button',
    (0, _extends3.default)({
      styleName: 'button ' + (disabled ? 'disabled' : '') + ' ' + (isPrimary ? '' : 'secondary'),
      disabled: disabled ? 'disabled' : null
    }, formSubmitAttributes, {
      onClick: onClick,
      type: type
    }),
    label
  );
};

BaseButton.propTypes = {
  disabled: _propTypes2.default.bool,
  formSubmitAttributes: _propTypes2.default.arrayOf(_propTypes2.default.string),
  label: _propTypes2.default.string,
  isPrimary: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  type: _propTypes2.default.string
};

BaseButton.defaultProps = {
  disabled: null,
  formSubmitAttributes: [],
  label: '',
  isPrimary: true,
  onClick: function onClick() {},
  type: 'button'
};

exports.default = (0, _reactCssModules2.default)(BaseButton, _styles2.default, { allowMultiple: true });