'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getNested = require('get-nested');

var _getNested2 = _interopRequireDefault(_getNested);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var regex = /{{(\w+)}}/g;

function parseTemplate(formStore, text) {
  // First check if it is really a string
  if (typeof text !== 'string' || typeof text.replace !== 'function') {
    console.info('Tried to template', text, 'but it doesn\'t have a replace function');
    return text;
  }

  return text.replace(regex, function (found, variable) {
    return (0, _getNested2.default)(function () {
      return formStore.getField(variable).value || '';
    });
  });
}

exports.default = parseTemplate;