'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactCssModules = require('react-css-modules');

var _reactCssModules2 = _interopRequireDefault(_reactCssModules);

var _styles = require('./styles.pcss');

var _styles2 = _interopRequireDefault(_styles);

var _BaseInput = require('../BaseInput');

var _BaseInput2 = _interopRequireDefault(_BaseInput);

var _WebformElement = require('../WebformElement');

var _WebformElement2 = _interopRequireDefault(_WebformElement);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RangeField = (_dec = (0, _reactCssModules2.default)(_styles2.default, { allowMultiple: true }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(RangeField, _Component);

  function RangeField() {
    (0, _classCallCheck3.default)(this, RangeField);
    return (0, _possibleConstructorReturn3.default)(this, (RangeField.__proto__ || (0, _getPrototypeOf2.default)(RangeField)).apply(this, arguments));
  }

  (0, _createClass3.default)(RangeField, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // rewrite to 0 if not numeric
      var value = !isNaN(parseFloat(this.props.value)) && isFinite(this.props.value) ? this.props.value : 0;
      this.props.onChange(value);
    }
  }, {
    key: 'getLabelPositionClass',
    value: function getLabelPositionClass() {
      var labelClass = 'display-' + this.props.field['#title_display'];
      if (_styles2.default[labelClass]) {
        return labelClass;
      }
      return '';
    }
  }, {
    key: 'getPercentageValue',
    value: function getPercentageValue() {
      var minValue = parseFloat(this.props.field['#min']);
      var range = parseFloat(this.props.field['#max']) - minValue;
      var rangeValue = (this.props.value - minValue) / range;
      rangeValue = isFinite(rangeValue) ? rangeValue : 0;
      rangeValue = rangeValue > 0 ? rangeValue : 0;

      return rangeValue * 100;
    }
  }, {
    key: 'render',
    value: function render() {
      var cssClassesWrapper = 'input-wrapper ' + this.getLabelPositionClass();

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { styleName: cssClassesWrapper },
          _react2.default.createElement(_BaseInput2.default, (0, _extends3.default)({}, this.props, {
            type: 'range',
            styleName: 'range'
          })),
          _react2.default.createElement(
            'span',
            { styleName: 'range-value-wrapper ' + this.getLabelPositionClass() },
            _react2.default.createElement(
              'span',
              { styleName: 'range-value', style: { left: this.getPercentageValue() + '%' } },
              this.props.value
            )
          ),
          _react2.default.createElement('span', { styleName: 'validation-icon ' + (this.props.webformElement.isSuccess() ? 'validate-success' : '') })
        )
      );
    }
  }]);
  return RangeField;
}(_react.Component), _class2.propTypes = {
  field: _propTypes2.default.shape({
    '#title_display': _propTypes2.default.string,
    '#min': _propTypes2.default.string,
    '#max': _propTypes2.default.string
  }).isRequired,
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool]).isRequired,
  onChange: _propTypes2.default.func.isRequired,
  webformElement: _propTypes2.default.instanceOf(_WebformElement2.default).isRequired
}, _temp)) || _class);
exports.default = RangeField;