'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getNested = require('get-nested');

var _getNested2 = _interopRequireDefault(_getNested);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactCssModules = require('react-css-modules');

var _reactCssModules2 = _interopRequireDefault(_reactCssModules);

var _mobxReact = require('mobx-react');

var _LookUp = require('../LookUp');

var _LookUp2 = _interopRequireDefault(_LookUp);

var _Fieldset = require('../Fieldset');

var _Fieldset2 = _interopRequireDefault(_Fieldset);

var _RuleHint = require('../RuleHint');

var _RuleHint2 = _interopRequireDefault(_RuleHint);

var _styles = require('./styles.pcss');

var _styles2 = _interopRequireDefault(_styles);

var _Form = require('../Observables/Form');

var _Form2 = _interopRequireDefault(_Form);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Relation = (_dec = (0, _reactCssModules2.default)(_styles2.default), (0, _mobxReact.observer)(_class = _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Relation, _Component);

  function Relation(props) {
    (0, _classCallCheck3.default)(this, Relation);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Relation.__proto__ || (0, _getPrototypeOf2.default)(Relation)).call(this, props));

    _this.lookUpFields = {
      relation_number: {
        formKey: 'relation_number' + props.formKeySuffix,
        triggerLookup: true,
        apiValue: function apiValue() {
          return false;
        },
        required: true
      },
      postcode: {
        formKey: 'address_postcode' + (_this.fullAddressLookUp() ? '-' + _this.fullAddressLookUp() : props.formKeySuffix),
        triggerLookup: true,
        apiValue: function apiValue() {
          return false;
        },
        required: true
      }
    };

    _this.lookUpBase = props.webformSettings.cmsBaseUrl + '/salesforce-lookup/contact?_format=json';
    return _this;
  }

  /**
   * If Relation field has full address element, get its webform key to add as suffix to fields.
   * @returns {bool|string} Returns false if not full address field (i.e. postcode only) or string of address webform key.
   */


  (0, _createClass3.default)(Relation, [{
    key: 'fullAddressLookUp',
    value: function fullAddressLookUp() {
      var _this2 = this;

      return (0, _getNested2.default)(function () {
        return _this2.props.field.composite_elements.find(function (element) {
          return element['#type'] === 'webform_address_custom';
        })['#webform_key'];
      });
    }
  }, {
    key: 'prepareLookUp',
    value: function prepareLookUp(fields) {
      var performLookUp = true;
      this.props.fieldIterator(function (field, element) {
        if (field.required && (!fields[element.elementKey] || !field.valid)) {
          performLookUp = false;
          return false;
        }
        return true;
      });

      if (!performLookUp) {
        return false;
      }

      var query = '&relation=' + fields.relation_number + '&postal_code=' + fields.postcode;

      return {
        query: query,
        checkResponse: function checkResponse(json) {
          return json.Id || false;
        },
        isSuccessful: function isSuccessful(response) {
          return !!response;
        }
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var field = this.props.formStore.getField(this.lookUpFields.relation_number.formKey);
      return _react2.default.createElement(
        _Fieldset2.default,
        (0, _extends3.default)({}, this.props, {
          onBlur: this.props.onBlur
        }),
        field.lookupSent && !field.lookupSuccessful && _react2.default.createElement(_RuleHint2.default, { component: _react2.default.createElement('p', { className: _styles2.default['validation-message'] }), key: 'relation_' + this.props.field['#webform_key'], hint: _Fieldset2.default.getValue(this.props.field, 'relationError') || 'We don\'t recognise this combination of relation number and postal code. Please check again, or proceed anyway.' })
      );
    }
  }]);
  return Relation;
}(_react.Component), _class2.meta = {
  labelVisibility: _Fieldset2.default.meta.labelVisibility
}, _class2.propTypes = {
  field: _propTypes2.default.shape({
    '#webform_key': _propTypes2.default.string.isRequired,
    '#relationError': _propTypes2.default.string,
    composite_elements: _propTypes2.default.arrayOf(_propTypes2.default.shape())
  }).isRequired,
  webformSettings: _propTypes2.default.shape({
    cmsBaseUrl: _propTypes2.default.string.isRequired
  }).isRequired,
  fieldIterator: _propTypes2.default.func.isRequired,
  onBlur: _propTypes2.default.func.isRequired,
  formKeySuffix: _propTypes2.default.string.isRequired,
  formStore: _propTypes2.default.instanceOf(_Form2.default).isRequired
}, _temp)) || _class) || _class);
exports.default = (0, _LookUp2.default)(Relation);