'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactCssModules = require('react-css-modules');

var _reactCssModules2 = _interopRequireDefault(_reactCssModules);

var _styles = require('./styles.pcss');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getStepClass(i) {
  var stepClass = 'step-' + i;
  if (_styles2.default[stepClass]) {
    return stepClass;
  }
  return '';
}

function WizardProgress(_ref) {
  var pages = _ref.pages,
      currentPage = _ref.currentPage;

  return _react2.default.createElement(
    'ul',
    { styleName: 'bar' },
    pages.map(function (page, i) {
      var classList = 'step ' + getStepClass(i + 1);

      switch (true) {
        case i < currentPage:
          classList = classList + ' done';
          break;
        case i === currentPage:
          classList = classList + ' active';
          break;
        default:
          //   classList = `${classList} todo`;
          break;
      }

      return _react2.default.createElement(
        'li',
        { key: page['#webform_key'], styleName: classList, style: { width: 100 / pages.length + '%' } },
        _react2.default.createElement(
          'span',
          { styleName: 'step-number' },
          i + 1
        ),
        _react2.default.createElement(
          'span',
          { styleName: 'step-title' },
          page['#title']
        )
      );
    })
  );
}

WizardProgress.propTypes = {
  pages: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    '#title': _propTypes2.default.string.isRequired,
    '#webform_key': _propTypes2.default.string.isRequired
  })).isRequired,
  currentPage: _propTypes2.default.number.isRequired
};

exports.default = (0, _reactCssModules2.default)(WizardProgress, _styles2.default, { allowMultiple: true });